`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:35:09 03/14/2008 
// Design Name: 
// Module Name:    Demo_Top 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module LED_F(
							clk,
							rst,
							st,
							// ---------------- +++++++
							Led,
							// ---------------- +++++++
							sec_out
							//--------------  ++++

							

													);
													
//------------------  IO -------------------------------

input				clk;
input				rst;
input				st;
output			sec_out;	

output [7:0]	Led;

//=============================

//z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{
// |}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|
//wwwwwwww{       zwwwwww{   zwwwwwwwwwwwwwwwww
//			 |wwwwwww}      |www}
//=======OOOO========================OOO=====


reg	[27:0]	sec_cnt;
reg	[7:0]		Led_m;
reg	sec_out;

// ===========  FSM =======================

reg [3:0]  	CSTATE;
parameter [3:0] 
	IDLE	 	= 4'h0,
	SC_1		= 4'h1,
	SC_2		= 4'h2,
	SC_3		= 4'h3,
	SC_4		= 4'h4,
	SC_5		= 4'h5,
	SC_6		= 4'h6,
	SC_7		= 4'h7,
	SC_8		= 4'h8,
	SC_9		= 4'h9,
	SC_10		= 4'hA,
	SC_11		= 4'hB,
	SC_12		= 4'hC,
	SC_13		= 4'hD,
	SC_14		= 4'hE,
	SC_15		= 4'hF;

//============================================

//wire tnt = secD4_cnt[0];
wire tnt = sec_cnt[0];
wire n_rst = ~rst;
//-----------------<<>>><<<>>>><<<>>------------------------------

always @ ( posedge clk   )
begin
if ( !n_rst )
	begin sec_cnt <= 28'h0; sec_out <= 1'b0; end
else
	begin
	//	if ( sec_cnt >= 28'h17D7840 )		 // 50 MHZ	
	//	if ( sec_cnt >= 28'h2FAF080 )		 //100 MHZ
		if ( sec_cnt >= 28'h0000002 )
			begin sec_out <= ~sec_out;  sec_cnt <= 28'h0; end
		else
			begin	sec_cnt <= sec_cnt + 1 ; sec_out <= sec_out; end
	end
end
//-----------------<<>>><<<>>>><<<>>------------------------------

//-----------------<<>>><<<>>>><<<>>------------------------------
always @ ( posedge sec_out or negedge n_rst ) 
begin
if ( !n_rst ) begin CSTATE <= IDLE; Led_m <= 8'h0; end
else
	begin
		case ( CSTATE )
		IDLE	: begin 
					if ( st )
					begin	CSTATE <= SC_1; Led_m <= 8'b00000001; end	
					else
					begin	CSTATE <= IDLE; Led_m <= 8'b00000000; end		
				  end
		SC_1 	: begin CSTATE <= SC_2;  	Led_m <= 8'b00000010; end
		SC_2 	: begin CSTATE <= SC_3; 	Led_m <= 8'b00000100; end
		SC_3 	: begin CSTATE <= SC_4; 	Led_m <= 8'b00001000; end
		SC_4 	: begin CSTATE <= SC_5; 	Led_m <= 8'b00010000; end
		SC_5	: begin CSTATE <= SC_6;  	Led_m <= 8'b00100000; end
		SC_6 	: begin CSTATE <= SC_7; 	Led_m <= 8'b01000000; end
		SC_7  : begin CSTATE <= SC_8; 	Led_m <= 8'b10000000; end
		SC_8  : begin CSTATE <= SC_9;		Led_m <= 8'b10000000; end
		SC_9  : begin CSTATE <= SC_10;  	Led_m <= 8'b01000000; end
		SC_10 : begin CSTATE <= SC_11;  	Led_m <= 8'b00100000; end
		SC_11 : begin CSTATE <= SC_12;  	Led_m <= 8'b00010000; end
		SC_12 : begin CSTATE <= SC_13;  	Led_m <= 8'b00001000; end
		SC_13 : begin CSTATE <= SC_14;  	Led_m <= 8'b00000100; end
		SC_14 : begin CSTATE <= SC_15;  	Led_m <= 8'b00000010; end
		SC_15 : begin CSTATE <= IDLE;  	Led_m <= 8'b00000001; end
		endcase
	end
end
//-----------------<<>>><<<>>>><<<>>------------------------------


assign Led[0] = Led_m[0] & tnt; 
assign Led[1] = Led_m[1] & tnt;
assign Led[2] = Led_m[2] & tnt;
assign Led[3] = Led_m[3] & tnt;
assign Led[4] = Led_m[4] & tnt;
assign Led[5] = Led_m[5] & tnt;
assign Led[6] = Led_m[6] & tnt;
assign Led[7] = Led_m[7] & tnt;


/*
assign Led[0] = ( sel_ch == 2'b00 ) ? ( Led_m[0] & tnt ) : 1'b0;
assign Led[1] = ( sel_ch == 2'b00 ) ? ( Led_m[1] & tnt ) : 1'b0;
assign Led[2] = ( sel_ch == 2'b00 ) ? ( Led_m[2] & tnt ) : 1'b0;
assign Led[3] = ( sel_ch == 2'b00 ) ? ( Led_m[3] & tnt ) : 1'b0;
assign Led[4] = ( sel_ch == 2'b00 ) ? ( Led_m[4] & tnt ) : 1'b0;
assign Led[5] = ( sel_ch == 2'b00 ) ? ( Led_m[5] & tnt ) : 1'b0;
assign Led[6] = ( sel_ch == 2'b00 ) ? ( Led_m[6] & tnt ) : 1'b0;
assign Led[7] = ( sel_ch == 2'b00 ) ? ( Led_m[7] & tnt ) : 1'b0;
*/
//==============   (( CALL IP MODULE ))  ==================
/*
Dll_M2D4 instance_name (
    .CLKIN_IN( clk ), 
    .RST_IN( rst ), 
    .CLKDV_OUT( clkD4 ), 
    //.CLKIN_IBUFG_OUT(CLKIN_IBUFG_OUT), 
    .CLK0_OUT( clkM2 ), 
    .LOCKED_OUT( dll_lock )
    );
*/
//====================== OOOOOOOOOOO =========================	 
endmodule
