////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995-2003 Xilinx, Inc.
// All Right Reserved.
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 9.1.03i
//  \   \         Application : ISE
//  /   /         Filename : tb_x01.tfw
// /___/   /\     Timestamp : Fri Mar 14 02:00:52 2008
// \   \  /  \ 
//  \___\/\___\ 
//
//Command: 
//Design Name: tb_x01_tb_0
//Device: Xilinx
//
`timescale 1ns/1ps

module tb_x01_tb_0;
    reg clk = 1'b0;
    reg n_rst = 1'b0;
    reg [2:0] sel_ch = 3'b000;
    wire out_1_ch;
    wire out_2_ch;
    wire out_3_ch;
    wire out_4_ch;
    wire fS_1;
    wire fS_2;
    wire fS_3;
    wire fS_4;

    parameter PERIOD = 20;
    parameter real DUTY_CYCLE = 0.5;
    parameter OFFSET = 10;

    initial    // Clock process for clk
    begin
        #OFFSET;
        forever
        begin
            clk = 1'b0;
            #(PERIOD-(PERIOD*DUTY_CYCLE)) clk = 1'b1;
            #(PERIOD*DUTY_CYCLE);
        end
    end

    Demo_Top UUT (
        .clk(clk),
        .n_rst(n_rst),
        .sel_ch(sel_ch),
        .out_1_ch(out_1_ch),
        .out_2_ch(out_2_ch),
        .out_3_ch(out_3_ch),
        .out_4_ch(out_4_ch),
        .fS_1(fS_1),
        .fS_2(fS_2),
        .fS_3(fS_3),
        .fS_4(fS_4));

    initial begin
        // -------------  Current Time:  58ns
        #58;
        n_rst = 1'b1;
        sel_ch = 3'b001;
        // -------------------------------------
    end

endmodule

